=== data/CMakeLists.txt ===
message("\n${BoldGreen}Beginning configuration for subdirectory data${ColourReset}\n")


message("\n${BoldGreen}Installation directory for the data files: ${PROJECT_INSTALL_CHEMDATA_DIR}${ColourReset}\n")

INSTALL (DIRECTORY polChemDefs polSeqs dictionaries
	DESTINATION ${PROJECT_INSTALL_CHEMDATA_DIR})

INSTALL (FILES chemPad.conf
	DESTINATION ${PROJECT_INSTALL_CHEMDATA_DIR})

message("\n${BoldGreen}Ending configuration for subdirectory data${ColourReset}\n")
