=== debian/changelog ===
massxpert3 (10.4.0-1) unstable; urgency=low

  * New release with new ApplicationPreferencesWnd-associated features.

  * Depends on more recent libpappsomspp and libxpertmass.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 21 Feb 2026 15:45:35 +0100

massxpert3 (10.3.0-1) unstable; urgency=low

  * New release with reworked QSettings-based configuration and an
    implementation of the 'Recent files... ' menu.

  * Small bug fixes.

  * Depends on more recent libpappsomspp and libxpertmass.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 18 Dec 2025 19:31:40 +0100

massxpert3 (10.2.0-1) unstable; urgency=low

  * New release with new feature to allow phasing the bins in multiple
    isotopic cluster mass spectra combinations.

  * Update the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 04 Dec 2025 23:50:31 +0100

massxpert3 (10.1.2-1) unstable; urgency=low

  * New release depending on new version of XpertMass (bug fix over there).

  * General review of the user manual and update with the new documentation
    about the JavaScript features.

  * Overhaul of the org.msxpertsuite.MassXpert3.metainfo.xml file. Update
    of the links to screenshots.

  * Redone all the identity artwork (icons and splashscren).

  * Update the build-dependencies over libraries.

  * Remove build-dep on imagemagick-6-common. We'll see.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 21 Nov 2025 23:05:11 +0100

massxpert3 (10.1.1-1) unstable; urgency=low

  * New release fixing the versioning in the user manual
    user-manual-version-entity.ent file.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 30 Oct 2025 00:13:41 +0100

massxpert3 (10.1.0-1) UNRELEASED; urgency=low

  * New release with a bunch of dependee updates (libpwizlite,
    libisospec, libpappsomspp).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 29 Oct 2025 23:24:09 +0100

massxpert3 (10.0.0-1) unstable; urgency=low

  * New release of version 10.0.0, the first version of massxpert3 series.
    This is a full rewrite of MassXpert as software that depends on the
    libXpertMassCore and libXpertMassGui libraries which have been fully
    rewritten.
  * JavaScript-based scripting is now possible thanks to the JS scripting
    abilities of these two libraries.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 29 May 2025 12:34:10 +0200

massxpert3 (8.6.0-1) UNRELEASED; urgency=low

  * Mainly build system improvements.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 22 Jul 2024 12:48:40 +0200

massxpert3 (8.5.0-1) unstable; urgency=low

  * Big new upstream version that now relies on shared libraries
    libxpertmass and libxpertmass-gui instead of having the two
    static libraries made inside the source tree.

    Thus, now depends on libxpertmass-dev (>= 1.0.0).

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 22 Jul 2024 12:48:40 +0200

massxpert3 (8.4.1-1) unstable; urgency=low

  * Small fixes.
  * Update dependency version for libpappsomspp.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 01 Jun 2024 13:52:44 +0200

massxpert3 (8.4.0-1) unstable; urgency=low

  * Add new polymer chemistry definition for fully labelled N;
  * Improve the ChemicalPad config for some sugars;
  * Implemented basic functionality in Averagine;
  * Allow using a double as a count for the formula;
  * Implemented the formula checkSyntax function using a RegularExpression;
  * Reconfigure the source tree to accomodate libmass and libmassgui
    as true git submodules;
  * MXE-based build works flawlessly;
  * Network-based communications between mineXpert2 and massXpert2
    now work perfectly;
  * Updated the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 02 May 2024 14:11:55 +0200

massxpert3 (8.3.1-1) unstable; urgency=low

  * Rework the user manual build system.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 07 Dec 2023 12:17:36 +0100

massxpert3 (8.3.0-1) unstable; urgency=low

  * New upstream version:

    * New polymer chemistry definition with 98% labelled C13 and N15.
    * Fix crash with QTimer triggering single shot after its destruction.
    * Code cleanup and fix to memory leak in client-server code.
    * Compile the user manual in the binary source tree

  * Standards-Version: 4.6.2

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 21 Nov 2023 16:23:48 +0100

massxpert3 (8.2.0-1) unstable; urgency=low

  * New upstream package.

  * Two metapackages ensure that an upgrade of massxpert (or massxpert-doc)
    pulls in the new packages.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 23 Jun 2023 16:37:54 +0200

massxpert3 (8.1.0-1) unstable; urgency=low

  * New upstream version featuring the dynamic loading of isotopic data from
    disk files in the sequence editor, the cleavage dialog window and the
    fragmentation dialog window.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 20 Jun 2023 17:23:30 +0200

massxpert3 (8.0.1-1) unstable; urgency=low

  * New upstream version fixing bug with synthetic mass spectrum
    normalization.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 27 Apr 2023 13:34:52 +0200

massxpert3 (8.0.0-1) unstable; urgency=low

  * Rename the software massXpert -> massXpert2.

  * Refactoring all the framework describing the chemical entities: abandoned
    the Atom/AtomCount paradigm in favor of a complete list of isotopes
    (IsotopicData). This works aims at streamlining all the future features
    related to isotopic cluster modelling.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 16 Feb 2023 13:07:18 +0100

massxpert (7.1.0-1) unstable; urgency=low

  * New version implementing a new project hierarchy: libmass and libmassgui
    private static libraries enshrine all the functionalities that might be
    used in other project. The implementation is based on git submodules.

  * Added the possibility to perform isotopic cluster calculations and mass
    peak shape calculations.

  * Added build dependencies for the new features.


