=== debian/control ===
Source: massxpert3
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 13),
 dpkg-dev (>= 1.21.22),
# To export from svg to png
 librsvg2-bin,
 qt6-base-dev,
 libqt6svg6-dev,
 qt6-declarative-dev,
 libqt6core5compat6-dev,
 libxkbcommon-x11-dev,
 cmake,
 daps,
 libjs-jquery,
 libjs-highlight.js,
 texlive-fonts-extra,
 fonts-ebgaramond-extra,
 fonts-urw-base35,
# Only the logically essential one.
 libpappsomspp-gui-dev (>= 0.11.10),
# Only the logically essential one.
 libxpertmassgui-dev (>= 1.8.1),
 libqscintilla2-qt6-dev,
 libisospec++-dev (>=2.3.1),
 libpwizlite-dev,
 libsqlite3-dev,
 libzstd-dev,
 liblzf-dev,
 zlib1g-dev,
 libquazip1-qt6-dev,
 libqcustomplot-dev (>= 2.1.0),
 libodsstream-dev (>= 0.9.14),
 libboost1.88-dev,
 libboost-thread1.88-dev,
 libboost-system1.88-dev,
 libboost-filesystem1.88-dev,
 libboost-iostreams1.88-dev,
 libboost-chrono1.88-dev,
 libboost-random1.88-dev,
 libboost-container1.88-dev,
 docbook-xml,
 docbook-to-man
Standards-Version: 4.7.2
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/massxpert3
Vcs-Git: https://salsa.debian.org/debichem-team/massxpert3.git
Rules-Requires-Root: no

Package: massxpert2
Depends: massxpert3,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for massxpert2 -> massxpert3
 This is a transitional package. It can safely be removed.
 Runtime package.

Package: massxpert2-data
Depends: massxpert3-data,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for massxpert2-dat -> massxpert3-data
 This is a transitional package. It can safely be removed.
 Runtime package.


Package: massxpert-doc
Depends: massxpert3-doc,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for massxpert-doc -> massxpert3-doc
 This is a transitional package. It can safely be removed.
 Documentation package.


Package: massxpert2-doc
Depends: massxpert3-doc,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for massxpert2-doc -> massxpert3-doc
 This is a transitional package. It can safely be removed.
 Documentation package.


Package: massxpert3
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         massxpert3-data (>= ${source:Upstream-Version})
Suggests: massxpert3-doc (>= ${source:Upstream-Version})
Replaces: massxpert, massxpert2
Breaks: massxpert, massxpert2
Description: polymer chemistry modelling and mass spectrometry data simulation (runtime)
 MassXpert3 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the massXpert3 program.


Package: massxpert3-data
Architecture: all
Depends: ${misc:Depends},
Suggests: massxpert3-doc (>= ${source:Upstream-Version})
Replaces: massxpert2-data
Breaks: massxpert2-data
Description: polymer chemistry modelling and mass spectrometry data simulation (data)
 MassXpert3 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the polymer chemistry data.


Package: massxpert3-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Replaces: massxpert2-doc
Breaks: massxpert2-doc
Description: polymer chemistry modelling and mass spectrometry data simulation (doc)
 MassXpert3 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the user manual in both PDF and HTML formats.
